Index: pjproject/trunk/pjsip-apps/src/py_pjsua/py_pjsua.c
===================================================================
--- pjproject/trunk/pjsip-apps/src/py_pjsua/py_pjsua.c	(revision 850)
+++ pjproject/trunk/pjsip-apps/src/py_pjsua/py_pjsua.c	(revision 851)
@@ -2944,5 +2818,5 @@
             return NULL;
         }
-		self->info = PyString_FromString("");
+        self->info = PyString_FromString("");
         if (self->info == NULL)
     	{
@@ -2951,5 +2825,5 @@
         }
         self->local_addr = 
-			(sockaddr_Object *)sockaddr_new(&sockaddr_Type,NULL,NULL);
+            (sockaddr_Object *)sockaddr_new(&sockaddr_Type,NULL,NULL);
         if (self->local_addr == NULL)
     	{
@@ -2958,5 +2832,5 @@
         }
         self->local_name = 
-			(host_port_Object *)host_port_new(&host_port_Type,NULL,NULL);
+            (host_port_Object *)host_port_new(&host_port_Type,NULL,NULL);
         if (self->local_name == NULL)
     	{
@@ -2975,43 +2849,43 @@
 static PyMemberDef transport_info_members[] =
 {
-	{
-    	"id", T_INT, offsetof(transport_info_Object, id), 0,
-    	"PJSUA transport identification."
-    },
-	{
-    	"type", T_INT, offsetof(transport_info_Object, id), 0,
-    	"Transport type."
-    },
-	{
-    	"type_name", T_OBJECT_EX,
-    	offsetof(transport_info_Object, type_name), 0,
-    	"Transport type name."
-    },
-	{
-    	"info", T_OBJECT_EX,
-    	offsetof(transport_info_Object, info), 0,
-    	"Transport string info/description."
-    },
-	{
-    	"flag", T_INT, offsetof(transport_info_Object, flag), 0,
-    	"Transport flag (see ##pjsip_transport_flags_e)."
-    },
-	{
-    	"addr_len", T_INT, offsetof(transport_info_Object, addr_len), 0,
-    	"Local address length."
-    },
-	{
-    	"local_addr", T_OBJECT_EX,
-    	offsetof(transport_info_Object, local_addr), 0,
-    	"Local/bound address."
-    },
-	{
-    	"local_name", T_OBJECT_EX,
-    	offsetof(transport_info_Object, local_name), 0,
-    	"Published address (or transport address name)."
-    },
-	{
-    	"usage_count", T_INT, offsetof(transport_info_Object, usage_count), 0,
-    	"Current number of objects currently referencing this transport."
+    {
+        "id", T_INT, offsetof(transport_info_Object, id), 0,
+        "PJSUA transport identification."
+    },
+    {
+        "type", T_INT, offsetof(transport_info_Object, id), 0,
+        "Transport type."
+    },
+    {
+        "type_name", T_OBJECT_EX,
+        offsetof(transport_info_Object, type_name), 0,
+        "Transport type name."
+    },
+    {
+        "info", T_OBJECT_EX,
+        offsetof(transport_info_Object, info), 0,
+        "Transport string info/description."
+    },
+    {
+        "flag", T_INT, offsetof(transport_info_Object, flag), 0,
+        "Transport flag (see ##pjsip_transport_flags_e)."
+    },
+    {
+        "addr_len", T_INT, offsetof(transport_info_Object, addr_len), 0,
+        "Local address length."
+    },
+    {
+        "local_addr", T_OBJECT_EX,
+        offsetof(transport_info_Object, local_addr), 0,
+        "Local/bound address."
+    },
+    {
+        "local_name", T_OBJECT_EX,
+        offsetof(transport_info_Object, local_name), 0,
+        "Published address (or transport address name)."
+    },
+    {
+        "usage_count", T_INT, offsetof(transport_info_Object, usage_count), 0,
+        "Current number of objects currently referencing this transport."
     },    
     {NULL}  /* Sentinel */
@@ -3112,4 +2986,5 @@
 /*
  * py_pjsua_stun_config_default
+ * !modified @ 051206
  */
 static PyObject *py_pjsua_stun_config_default(PyObject *pSelf, PyObject *pArgs)
@@ -3118,17 +2993,91 @@
     pjsua_stun_config cfg;
 
+    if (!PyArg_ParseTuple(pArgs, ""))
+    {
+        return NULL;
+    }
+	
+    pjsua_stun_config_default(&cfg);
+	obj = (stun_config_Object *)stun_config_new(&stun_config_Type, NULL, NULL);
+    obj->stun_port1 = cfg.stun_port1;
+    obj->stun_port2 = cfg.stun_port2;
+    Py_XDECREF(obj->stun_srv1);
+    obj->stun_srv1 = 
+        PyString_FromStringAndSize(cfg.stun_srv1.ptr, cfg.stun_srv1.slen);
+    Py_XDECREF(obj->stun_srv2);
+    obj->stun_srv2 = 
+        PyString_FromStringAndSize(cfg.stun_srv2.ptr, cfg.stun_srv2.slen);
+    return (PyObject *)obj;
+}
+
+/*
+ * py_pjsua_transport_config_default
+ * !modified @ 051206
+ */
+static PyObject *py_pjsua_transport_config_default
+(PyObject *pSelf, PyObject *pArgs)
+{
+    transport_config_Object *obj;
+    pjsua_transport_config cfg;
+
+    if (!PyArg_ParseTuple(pArgs, ""))
+    {
+        return NULL;
+    }
+    pjsua_transport_config_default(&cfg);
+	obj = (transport_config_Object *)transport_config_new
+		(&transport_config_Type,NULL,NULL);
+    obj->public_addr = 
+        PyString_FromStringAndSize(cfg.public_addr.ptr, cfg.public_addr.slen);
+    obj->bound_addr = 
+        PyString_FromStringAndSize(cfg.bound_addr.ptr, cfg.bound_addr.slen);
+    obj->port = cfg.port;
+    obj->use_stun = cfg.use_stun;
+    Py_XDECREF(obj->stun_config);
+    obj->stun_config = 
+        (stun_config_Object *)stun_config_new(&stun_config_Type, NULL, NULL);
+    obj->stun_config->stun_port1 = cfg.stun_config.stun_port1;
+    obj->stun_config->stun_port2 = cfg.stun_config.stun_port2;
+    Py_XDECREF(obj->stun_config->stun_srv1);
+    obj->stun_config->stun_srv1 = 
+        PyString_FromStringAndSize(cfg.stun_config.stun_srv1.ptr, 
+    cfg.stun_config.stun_srv1.slen);
+    Py_XDECREF(obj->stun_config->stun_srv2);
+    obj->stun_config->stun_srv2 = 
+        PyString_FromStringAndSize(cfg.stun_config.stun_srv2.ptr, 
+    cfg.stun_config.stun_srv2.slen);
+    return (PyObject *)obj;
+}
+
+/*
+ * py_pjsua_normalize_stun_config
+ */
+static PyObject *py_pjsua_normalize_stun_config
+(PyObject *pSelf, PyObject *pArgs)
+{
+    stun_config_Object *obj;
+    pjsua_stun_config *cfg;
+
     if (!PyArg_ParseTuple(pArgs, "O", &obj))
     {
         return NULL;
     }
-    pjsua_stun_config_default(&cfg);
-    obj->stun_port1 = cfg.stun_port1;
-	obj->stun_port2 = cfg.stun_port2;
-	Py_XDECREF(obj->stun_srv1);
+    cfg = (pjsua_stun_config *)malloc(sizeof(pjsua_stun_config));
+    cfg->stun_port1 = obj->stun_port1;
+    cfg->stun_port2 = obj->stun_port2;
+    cfg->stun_srv1.ptr = PyString_AsString(obj->stun_srv1);
+    cfg->stun_srv1.slen = strlen(PyString_AsString(obj->stun_srv1));
+    cfg->stun_srv2.ptr = PyString_AsString(obj->stun_srv2);
+    cfg->stun_srv2.slen = strlen(PyString_AsString(obj->stun_srv2));
+    pjsua_normalize_stun_config(cfg);
+    obj->stun_port1 = cfg->stun_port1;
+    obj->stun_port2 = cfg->stun_port2;
+    Py_XDECREF(obj->stun_srv1);
     obj->stun_srv1 = 
-		PyString_FromStringAndSize(cfg.stun_srv1.ptr, cfg.stun_srv1.slen);
-	Py_XDECREF(obj->stun_srv2);
-	obj->stun_srv2 = 
-		PyString_FromStringAndSize(cfg.stun_srv2.ptr, cfg.stun_srv2.slen);
+        PyString_FromStringAndSize(cfg->stun_srv1.ptr, cfg->stun_srv1.slen);
+    Py_XDECREF(obj->stun_srv2);
+    obj->stun_srv2 = 
+        PyString_FromStringAndSize(cfg->stun_srv2.ptr, cfg->stun_srv2.slen);
+    free(cfg);
     Py_INCREF(Py_None);
     return Py_None;
@@ -3136,298 +3085,131 @@
 
 /*
- * py_pjsua_transport_config_default
- */
-static PyObject *py_pjsua_transport_config_default
-(PyObject *pSelf, PyObject *pArgs)
-{
+ * py_pjsua_transport_create
+ * !modified @ 051206
+ */
+static PyObject *py_pjsua_transport_create(PyObject *pSelf, PyObject *pArgs)
+{
+    pj_status_t status;
+    int type;
+    
     transport_config_Object *obj;
     pjsua_transport_config cfg;
-
+    pjsua_transport_id id;
+    if (!PyArg_ParseTuple(pArgs, "iO", &type, &obj))
+    {
+        return NULL;
+    }
+    cfg.public_addr.ptr = PyString_AsString(obj->public_addr);
+    cfg.public_addr.slen = strlen(PyString_AsString(obj->public_addr));
+    cfg.bound_addr.ptr = PyString_AsString(obj->bound_addr);
+    cfg.bound_addr.slen = strlen(PyString_AsString(obj->bound_addr));
+    cfg.port = obj->port;
+    cfg.use_stun = obj->use_stun;
+    cfg.stun_config.stun_port1 = obj->stun_config->stun_port1;
+    cfg.stun_config.stun_port2 = obj->stun_config->stun_port2;
+    cfg.stun_config.stun_srv1.ptr = 
+        PyString_AsString(obj->stun_config->stun_srv1);
+    cfg.stun_config.stun_srv1.slen = 
+        strlen(PyString_AsString(obj->stun_config->stun_srv1));
+    cfg.stun_config.stun_srv2.ptr = 
+        PyString_AsString(obj->stun_config->stun_srv2);
+    cfg.stun_config.stun_srv2.slen = 
+        strlen(PyString_AsString(obj->stun_config->stun_srv2));
+    status = pjsua_transport_create(type, &cfg, &id);
+    
+    
+    return Py_BuildValue("ii",status,id);
+}
+
+/*
+ * py_pjsua_transport_register
+ * !modified @ 051206
+ */
+static PyObject *py_pjsua_transport_register(PyObject *pSelf, PyObject *pArgs)
+{
+    pj_status_t status;	    
+    pjsip_transport_Object *obj;	
+    pjsua_transport_id id;
     if (!PyArg_ParseTuple(pArgs, "O", &obj))
     {
         return NULL;
     }
-    pjsua_transport_config_default(&cfg);
-    obj->public_addr = 
-		PyString_FromStringAndSize(cfg.public_addr.ptr, cfg.public_addr.slen);
-	obj->bound_addr = 
-		PyString_FromStringAndSize(cfg.bound_addr.ptr, cfg.bound_addr.slen);
-	obj->port = cfg.port;
-	obj->use_stun = cfg.use_stun;
-	Py_XDECREF(obj->stun_config);
-	obj->stun_config = 
-		(stun_config_Object *)stun_config_new(&stun_config_Type, NULL, NULL);
-    obj->stun_config->stun_port1 = cfg.stun_config.stun_port1;
-	obj->stun_config->stun_port2 = cfg.stun_config.stun_port2;
-	Py_XDECREF(obj->stun_config->stun_srv1);
-    obj->stun_config->stun_srv1 = 
-		PyString_FromStringAndSize(cfg.stun_config.stun_srv1.ptr, 
-		cfg.stun_config.stun_srv1.slen);
-	Py_XDECREF(obj->stun_config->stun_srv2);
-	obj->stun_config->stun_srv2 = 
-		PyString_FromStringAndSize(cfg.stun_config.stun_srv2.ptr, 
-		cfg.stun_config.stun_srv2.slen);
-    Py_INCREF(Py_None);
-    return Py_None;
-}
-
-/*
- * py_pjsua_normalize_stun_config
- */
-static PyObject *py_pjsua_normalize_stun_config
-(PyObject *pSelf, PyObject *pArgs)
-{
-    stun_config_Object *obj;
-    pjsua_stun_config *cfg;
-
-    if (!PyArg_ParseTuple(pArgs, "O", &obj))
-    {
-        return NULL;
-    }
-	cfg = (pjsua_stun_config *)malloc(sizeof(pjsua_stun_config));
-	cfg->stun_port1 = obj->stun_port1;
-	cfg->stun_port2 = obj->stun_port2;
-	cfg->stun_srv1.ptr = PyString_AsString(obj->stun_srv1);
-	cfg->stun_srv1.slen = strlen(PyString_AsString(obj->stun_srv1));
-	cfg->stun_srv2.ptr = PyString_AsString(obj->stun_srv2);
-	cfg->stun_srv2.slen = strlen(PyString_AsString(obj->stun_srv2));
-    pjsua_normalize_stun_config(cfg);
-    obj->stun_port1 = cfg->stun_port1;
-	obj->stun_port2 = cfg->stun_port2;
-	Py_XDECREF(obj->stun_srv1);
-    obj->stun_srv1 = 
-		PyString_FromStringAndSize(cfg->stun_srv1.ptr, cfg->stun_srv1.slen);
-	Py_XDECREF(obj->stun_srv2);
-	obj->stun_srv2 = 
-		PyString_FromStringAndSize(cfg->stun_srv2.ptr, cfg->stun_srv2.slen);
-	free(cfg);
-    Py_INCREF(Py_None);
-    return Py_None;
-}
-
-/*
- * py_pjsua_transport_config_dup
- */
-static PyObject *py_pjsua_transport_config_dup
-(PyObject *pSelf, PyObject *pArgs)
-{
-    pj_pool_Object *pool;
-    transport_config_Object *src;
-    transport_config_Object *dest;
-	pj_pool_t *p;
-	pjsua_transport_config s;
-	pjsua_transport_config d;	
-
-    if (!PyArg_ParseTuple(pArgs, "OOO", &pool, &dest, &src))
-    {
-        return NULL;
-    }
-    p = pool->pool;
-	s.public_addr.ptr = PyString_AsString(src->public_addr);
-	s.public_addr.slen = strlen(PyString_AsString(src->public_addr));
-	s.bound_addr.ptr = PyString_AsString(src->bound_addr);
-	s.bound_addr.slen = strlen(PyString_AsString(src->bound_addr));
-	s.port = src->port;
-	s.use_stun = src->use_stun;
-	s.stun_config.stun_port1 = src->stun_config->stun_port1;
-	s.stun_config.stun_port2 = src->stun_config->stun_port2;
-	s.stun_config.stun_srv1.ptr = 
-		PyString_AsString(src->stun_config->stun_srv1);
-	s.stun_config.stun_srv1.slen = 
-		strlen(PyString_AsString(src->stun_config->stun_srv1));
-	s.stun_config.stun_srv2.ptr = 
-		PyString_AsString(src->stun_config->stun_srv2);
-	s.stun_config.stun_srv2.slen = 
-		strlen(PyString_AsString(src->stun_config->stun_srv2));
-	d.public_addr.ptr = PyString_AsString(dest->public_addr);
-	d.public_addr.slen = strlen(PyString_AsString(dest->public_addr));
-	d.bound_addr.ptr = PyString_AsString(dest->bound_addr);
-	d.bound_addr.slen = strlen(PyString_AsString(dest->bound_addr));
-	d.port = dest->port;
-	d.use_stun = dest->use_stun;
-	d.stun_config.stun_port1 = dest->stun_config->stun_port1;
-	d.stun_config.stun_port2 = dest->stun_config->stun_port2;
-	d.stun_config.stun_srv1.ptr = 
-		PyString_AsString(dest->stun_config->stun_srv1);
-	d.stun_config.stun_srv1.slen = 
-		strlen(PyString_AsString(dest->stun_config->stun_srv1));
-	d.stun_config.stun_srv2.ptr = 
-		PyString_AsString(dest->stun_config->stun_srv2);
-	d.stun_config.stun_srv2.slen = 
-		strlen(PyString_AsString(dest->stun_config->stun_srv2));
-	pjsua_transport_config_dup(p, &d, &s);
-	src->public_addr = 
-		PyString_FromStringAndSize(s.public_addr.ptr, s.public_addr.slen);
-	src->bound_addr = 
-		PyString_FromStringAndSize(s.bound_addr.ptr, s.bound_addr.slen);
-	src->port = s.port;
-	src->use_stun = s.use_stun;
-	src->stun_config->stun_port1 = s.stun_config.stun_port1;
-	src->stun_config->stun_port2 = s.stun_config.stun_port2;
-	Py_XDECREF(src->stun_config->stun_srv1);
-	src->stun_config->stun_srv1 = 
-		PyString_FromStringAndSize(s.stun_config.stun_srv1.ptr, 
-		s.stun_config.stun_srv1.slen);
-	Py_XDECREF(src->stun_config->stun_srv2);
-	src->stun_config->stun_srv2 = 
-		PyString_FromStringAndSize(s.stun_config.stun_srv2.ptr, 
-		s.stun_config.stun_srv2.slen);	
-	dest->public_addr = 
-		PyString_FromStringAndSize(d.public_addr.ptr, d.public_addr.slen);
-	dest->bound_addr = 
-		PyString_FromStringAndSize(d.bound_addr.ptr, d.bound_addr.slen);
-	dest->port = d.port;
-	dest->use_stun = d.use_stun;
-	dest->stun_config->stun_port1 = d.stun_config.stun_port1;
-	dest->stun_config->stun_port2 = d.stun_config.stun_port2;
-	Py_XDECREF(dest->stun_config->stun_srv1);
-	dest->stun_config->stun_srv1 = 
-		PyString_FromStringAndSize(d.stun_config.stun_srv1.ptr, 
-		d.stun_config.stun_srv1.slen);
-	Py_XDECREF(dest->stun_config->stun_srv2);
-	dest->stun_config->stun_srv2 = 
-		PyString_FromStringAndSize(d.stun_config.stun_srv2.ptr, 
-		d.stun_config.stun_srv2.slen);
-    Py_INCREF(Py_None);
-    return Py_None;
-}
-
-/*
- * py_pjsua_transport_create
- */
-static PyObject *py_pjsua_transport_create(PyObject *pSelf, PyObject *pArgs)
+	
+    
+    status = pjsua_transport_register(obj->tp, &id);
+    
+    return Py_BuildValue("ii",status, id);
+}
+
+/*
+ * py_pjsua_enum_transports
+ */
+static PyObject *py_pjsua_enum_transports(PyObject *pSelf, PyObject *pArgs)
 {
     pj_status_t status;
-	int type;
-	transport_id_Object *p_id;
-	transport_config_Object *obj;
-	pjsua_transport_config cfg;
-	pjsua_transport_id id;
-    if (!PyArg_ParseTuple(pArgs, "iOO", &type, &obj, &p_id))
-    {
-        return NULL;
-    }
-	cfg.public_addr.ptr = PyString_AsString(obj->public_addr);
-	cfg.public_addr.slen = strlen(PyString_AsString(obj->public_addr));
-	cfg.bound_addr.ptr = PyString_AsString(obj->bound_addr);
-	cfg.bound_addr.slen = strlen(PyString_AsString(obj->bound_addr));
-	cfg.port = obj->port;
-	cfg.use_stun = obj->use_stun;
-	cfg.stun_config.stun_port1 = obj->stun_config->stun_port1;
-	cfg.stun_config.stun_port2 = obj->stun_config->stun_port2;
-	cfg.stun_config.stun_srv1.ptr = 
-		PyString_AsString(obj->stun_config->stun_srv1);
-	cfg.stun_config.stun_srv1.slen = 
-		strlen(PyString_AsString(obj->stun_config->stun_srv1));
-	cfg.stun_config.stun_srv2.ptr = 
-		PyString_AsString(obj->stun_config->stun_srv2);
-	cfg.stun_config.stun_srv2.slen = 
-		strlen(PyString_AsString(obj->stun_config->stun_srv2));
-    status = pjsua_transport_create(type, &cfg, &id);
-	p_id->transport_id = id;
-    printf("status %d\n",status);
-    return Py_BuildValue("i",status);
-}
-
-/*
- * py_pjsua_transport_register
- */
-static PyObject *py_pjsua_transport_register(PyObject *pSelf, PyObject *pArgs)
-{
-    pj_status_t status;	
-	transport_id_Object *p_id;
-	pjsip_transport_Object *obj;	
-	pjsua_transport_id id;
-    if (!PyArg_ParseTuple(pArgs, "OO", &obj, &p_id))
-    {
-        return NULL;
-    }
-	
-	id = p_id->transport_id;
-    status = pjsua_transport_register(obj->tp, &id);
-	p_id->transport_id = id;    
-    return Py_BuildValue("i",status);
-}
-
-/*
- * py_pjsua_enum_transports
- */
-static PyObject *py_pjsua_enum_transports(PyObject *pSelf, PyObject *pArgs)
+    PyObject *list;
+    
+    pjsua_transport_id *id;
+    int c, i;
+    if (!PyArg_ParseTuple(pArgs, "i", &c))
+    {
+        return NULL;
+    }	
+    
+    id = (pjsua_transport_id *)malloc(c * sizeof(pjsua_transport_id));
+    status = pjsua_enum_transports(id, &c);
+    
+    list = PyList_New(c);
+    for (i = 0; i < c; i++) 
+    {     
+        int ret = PyList_SetItem(list, i, Py_BuildValue("i", id[i]));
+        if (ret == -1) 
+        {
+            return NULL;
+        }
+    }
+    
+    free(id);
+    return Py_BuildValue("O",list);
+}
+
+/*
+ * py_pjsua_transport_get_info
+ * !modified @ 051206
+ */
+static PyObject *py_pjsua_transport_get_info(PyObject *pSelf, PyObject *pArgs)
 {
     pj_status_t status;
-	PyObject *list;
-	integer_Object *count;
-	pjsua_transport_id *id;
-	int c, i;
-    if (!PyArg_ParseTuple(pArgs, "OO", &list, &count))
+    int id;
+    transport_info_Object *obj;
+    pjsua_transport_info info;
+    
+
+    if (!PyArg_ParseTuple(pArgs, "i", &id))
     {
         return NULL;
     }	
-	c = count->integer;
-	id = (pjsua_transport_id *)malloc(c * sizeof(pjsua_transport_id));
-    status = pjsua_enum_transports(id, &c);
-	Py_XDECREF(list);
-	list = PyList_New(c);
-	for (i = 0; i < c; i++) {
-		int ret = PyList_SetItem(list, i, Py_BuildValue("i", id[i]));
-		if (ret == -1) {
-			return NULL;
-		}
-	}
-	count->integer = c;
-	free(id);
-    return Py_BuildValue("i",status);
-}
-
-/*
- * py_pjsua_transport_get_info
- */
-static PyObject *py_pjsua_transport_get_info(PyObject *pSelf, PyObject *pArgs)
-{
-    pj_status_t status;
-	int id;
-	transport_info_Object *obj;
-	pjsua_transport_info info;
-	char * str;
-	int len;
-	int i;
-
-    if (!PyArg_ParseTuple(pArgs, "iO", &id, &obj))
-    {
-        return NULL;
-    }	
-	info.addr_len = obj->addr_len;
-	info.flag = obj->flag;
-	info.id = obj->id;
-	info.info.ptr = PyString_AsString(obj->info);
-	info.info.slen = strlen(PyString_AsString(obj->info));
-	str = PyString_AsString(obj->local_addr->sa_data);
-	len = strlen(str);
-	if (len > 14) {
-		len = 14;
-	}
-	for (i = 0; i < len; i++) {
-		info.local_addr.sa_data[i] = str[i];
-	}
+    
+    status = pjsua_transport_get_info(id, &info);	
+    if (status == PJ_SUCCESS) {
+        obj = (transport_info_Object *) transport_info_new
+			(&transport_info_Type,NULL,NULL);
+        obj->addr_len = info.addr_len;
+        obj->flag = info.flag;
+        obj->id = info.id;
+        obj->info = PyString_FromStringAndSize(info.info.ptr, info.info.slen);
+        obj->local_addr->sa_data = 
+			PyString_FromStringAndSize(info.local_addr.sa_data, 14);
 #if defined(PJ_SOCKADDR_HAS_LEN) && PJ_SOCKADDR_HAS_LEN!=0
-	info.local_addr.sa_zero_len = obj->local_addr->sa_zero_len;
-	info.local_addr.sa_family = obj->local_addr->sa_family;
+        obj->local_addr->sa_zero_len = info.local_addr.sa_zero_len;
+        obj->local_addr->sa_family = info.local_addr.sa_family;
 #else
-	info.local_addr.sa_family = obj->local_addr->sa_family;
+        obj->local_addr->sa_family = info.local_addr.sa_family;
 #endif
-    status = pjsua_transport_get_info(id, &info);	
-    obj->addr_len = info.addr_len;
-	obj->flag = info.flag;
-	obj->id = info.id;
-	obj->info = PyString_FromStringAndSize(info.info.ptr, info.info.slen);
-	obj->local_addr->sa_data = 
-		PyString_FromStringAndSize(info.local_addr.sa_data, 14);
-#if defined(PJ_SOCKADDR_HAS_LEN) && PJ_SOCKADDR_HAS_LEN!=0
-	obj->local_addr->sa_zero_len = info.local_addr.sa_zero_len;
-	obj->local_addr->sa_family = info.local_addr.sa_family;
-#else
-	obj->local_addr->sa_family = info.local_addr.sa_family;
-#endif
-    return Py_BuildValue("i",status);
+        return Py_BuildValue("O", obj);
+    } else {
+        Py_INCREF(Py_None);
+        return Py_None;
+    }
 }
 
@@ -3439,6 +3221,6 @@
 {
     pj_status_t status;
-	int id;
-	int enabled;
+    int id;
+    int enabled;
     if (!PyArg_ParseTuple(pArgs, "ii", &id, &enabled))
     {
@@ -3456,6 +3238,6 @@
 {
     pj_status_t status;
-	int id;
-	int force;
+    int id;
+    int force;
     if (!PyArg_ParseTuple(pArgs, "ii", &id, &force))
     {
@@ -3468,48 +3250,43 @@
 
 static char pjsua_stun_config_default_doc[] =
-    "void py_pjsua.stun_config_default (py_pjsua.STUN_Config cfg) "
+    "py_pjsua.STUN_Config py_pjsua.stun_config_default () "
     "Call this function to initialize STUN config with default values.";
 static char pjsua_transport_config_default_doc[] =
-	"void py_pjsua.transport_config_default (py_pjsua.Transport_Config cfg) "
-	"Call this function to initialize UDP config with default values.";
+    "py_pjsua.Transport_Config py_pjsua.transport_config_default () "
+    "Call this function to initialize UDP config with default values.";
 static char pjsua_normalize_stun_config_doc[] =
-	"void py_pjsua.normalize_stun_config (py_pjsua.STUN_Config cfg) "
-	"Normalize STUN config. ";
-static char pjsua_transport_config_dup_doc[] =
-	"void py_pjsua.transport_config_dup (py_pjsua.Pool pool, "
-	"py_pjsua.Transport_Config dest, py_pjsua.Transport_Config dest) "
-	"Duplicate transport config. ";
+    "void py_pjsua.normalize_stun_config (py_pjsua.STUN_Config cfg) "
+    "Normalize STUN config. ";
 static char pjsua_transport_create_doc[] =
-	"void py_pjsua.transport_create (int type, "
-	"py_pjsua.Transport_Config cfg, py_pjsua.Transport_ID p_id) "
-	"Create SIP transport.";
+    "int, int py_pjsua.transport_create (int type, "
+    "py_pjsua.Transport_Config cfg) "
+    "Create SIP transport.";
 static char pjsua_transport_register_doc[] =
-	"void py_pjsua.transport_register "
-	"(py_pjsua.PJSIP_Transport tp, py_pjsua.Transport_ID p_id) "
-	"Register transport that has been created by application.";
+    "int, int py_pjsua.transport_register "
+    "(py_pjsua.PJSIP_Transport tp) "
+    "Register transport that has been created by application.";
 static char pjsua_enum_transports_doc[] =
-	"void py_pjsua.enum_transports "
-	"(py_pjsua.Transport_ID id[], py_pjsua.Integer count) "
-	"Enumerate all transports currently created in the system.";
+    "int[] py_pjsua.enum_transports (int count) "
+    "Enumerate all transports currently created in the system.";
 static char pjsua_transport_get_info_doc[] =
-	"void py_pjsua.transport_get_info "
-	"(py_pjsua.Transport_ID id, py_pjsua.Transport_Info info) "
-	"Get information about transports.";
+    "void py_pjsua.transport_get_info "
+    "(py_pjsua.Transport_ID id, py_pjsua.Transport_Info info) "
+    "Get information about transports.";
 static char pjsua_transport_set_enable_doc[] =
-	"void py_pjsua.transport_set_enable "
-	"(py_pjsua.Transport_ID id, int enabled) "
-	"Disable a transport or re-enable it. "
-	"By default transport is always enabled after it is created. "
-	"Disabling a transport does not necessarily close the socket, "
-	"it will only discard incoming messages and prevent the transport "
-	"from being used to send outgoing messages.";
+    "void py_pjsua.transport_set_enable "
+    "(py_pjsua.Transport_ID id, int enabled) "
+    "Disable a transport or re-enable it. "
+    "By default transport is always enabled after it is created. "
+    "Disabling a transport does not necessarily close the socket, "
+    "it will only discard incoming messages and prevent the transport "
+    "from being used to send outgoing messages.";
 static char pjsua_transport_close_doc[] =
-	"void py_pjsua.transport_close (py_pjsua.Transport_ID id, int force) "
-	"Close the transport. If transport is forcefully closed, "
-	"it will be immediately closed, and any pending transactions "
-	"that are using the transport may not terminate properly. "
-	"Otherwise, the system will wait until all transactions are closed "
-	"while preventing new users from using the transport, and will close "
-	"the transport when it is safe to do so.";
+    "void py_pjsua.transport_close (py_pjsua.Transport_ID id, int force) "
+    "Close the transport. If transport is forcefully closed, "
+    "it will be immediately closed, and any pending transactions "
+    "that are using the transport may not terminate properly. "
+    "Otherwise, the system will wait until all transactions are closed "
+    "while preventing new users from using the transport, and will close "
+    "the transport when it is safe to do so.";
 
 /* END OF LIB TRANSPORT */
@@ -3525,14 +3302,16 @@
     PyObject_HEAD
     /* Type-specific fields go here. */
-	int priority;	
-	PyObject * id;
-	PyObject * reg_uri;
-	int publish_enabled;
-	PyObject * force_contact;
-	unsigned proxy_cnt;
-	pj_str_t proxy[8];
-	unsigned reg_timeout;
-	unsigned cred_count;
-	pjsip_cred_info cred_info[8];
+    int priority;	
+    PyObject * id;
+    PyObject * reg_uri;
+    int publish_enabled;
+    PyObject * force_contact;
+    unsigned proxy_cnt;
+    /*pj_str_t proxy[8];*/
+    PyListObject * proxy;
+    unsigned reg_timeout;
+    unsigned cred_count;
+    /*pjsip_cred_info cred_info[8];*/
+    PyListObject * cred_info;
 } acc_config_Object;
 
@@ -3545,6 +3324,8 @@
 {
     Py_XDECREF(self->id); 
-	Py_XDECREF(self->reg_uri);
-	Py_XDECREF(self->force_contact);	
+    Py_XDECREF(self->reg_uri);
+    Py_XDECREF(self->force_contact);	
+    Py_XDECREF(self->proxy);
+    Py_XDECREF(self->cred_info);
     self->ob_type->tp_free((PyObject*)self);
 }
@@ -3563,5 +3344,5 @@
     if (self != NULL)
     {
-		self->id = PyString_FromString("");
+        self->id = PyString_FromString("");
         if (self->id == NULL)
     	{
@@ -3569,5 +3350,5 @@
             return NULL;
         }
-		self->reg_uri = PyString_FromString("");
+        self->reg_uri = PyString_FromString("");
         if (self->reg_uri == NULL)
     	{
@@ -3581,4 +3362,16 @@
             return NULL;
         }
+	self->proxy = (PyListObject *)PyList_New(8);
+	if (self->proxy == NULL)
+	{
+	    Py_DECREF(self);
+	    return NULL;
+	}
+	self->cred_info = (PyListObject *)PyList_New(8);
+	if (self->cred_info == NULL)
+	{
+	    Py_DECREF(self);
+	    return NULL;
+	}
     }
 
@@ -3586,126 +3379,4 @@
 }
 
-static PyObject * acc_config_get_proxy
-(acc_config_Object *self, PyObject * args)
-{
-	int idx;
-	pj_str_t elmt;
-	if (!PyArg_ParseTuple(args,"i",&idx)) 
-	{
-		return NULL;
-	}
-	if ((idx >= 0) && (idx < 8)) 
-	{
-		elmt = self->proxy[idx];
-	} 
-	else
-	{
-		return NULL;
-	}
-	return PyString_FromStringAndSize(elmt.ptr, elmt.slen);
-}
-
-static PyObject * acc_config_set_proxy
-(acc_config_Object *self, PyObject * args)
-{
-	int idx;
-	PyObject * str;	
-	if (!PyArg_ParseTuple(args,"iO",&idx, &str)) 
-	{
-		return NULL;
-	}
-	if ((idx >= 0) && (idx < 8)) 
-	{
-		self->proxy[idx].ptr = PyString_AsString(str);
-		self->proxy[idx].slen = strlen(PyString_AsString(str));
-	} 
-	else
-	{
-		return NULL;
-	}
-	Py_INCREF(Py_None);
-	return Py_None;
-}
-static PyObject * acc_config_get_cred_info
-(acc_config_Object *self, PyObject * args)
-{
-	int idx;
-	pjsip_cred_info elmt;
-	pjsip_cred_info_Object *obj;
-	if (!PyArg_ParseTuple(args,"i",&idx)) 
-	{
-		return NULL;
-	}
-	if ((idx >= 0) && (idx < 8)) 
-	{
-		elmt = self->cred_info[idx];
-	} 
-	else
-	{
-		return NULL;
-	}
-	obj = (pjsip_cred_info_Object *)
-		PyType_GenericNew(&pjsip_cred_info_Type, NULL, NULL);
-	obj->data = PyString_FromStringAndSize(elmt.data.ptr, elmt.data.slen);
-	obj->realm = PyString_FromStringAndSize(elmt.realm.ptr, elmt.realm.slen);
-	obj->scheme = 
-		PyString_FromStringAndSize(elmt.scheme.ptr, elmt.scheme.slen);
-	obj->username = 
-		PyString_FromStringAndSize(elmt.username.ptr, elmt.username.slen);
-	obj->data_type = elmt.data_type;
-	return (PyObject *)obj;
-}
-
-static PyObject * acc_config_set_cred_info
-(acc_config_Object *self, PyObject * args)
-{
-	int idx;
-	pjsip_cred_info_Object * obj;	
-	if (!PyArg_ParseTuple(args,"iO",&idx, &obj)) 
-	{
-		return NULL;
-	}
-	if ((idx >= 0) && (idx < 8)) 
-	{
-		self->cred_info[idx].data.ptr = PyString_AsString(obj->data);
-		self->cred_info[idx].data.slen = strlen(PyString_AsString(obj->data));
-		self->cred_info[idx].realm.ptr = PyString_AsString(obj->realm);
-		self->cred_info[idx].realm.slen = strlen(PyString_AsString(obj->realm));
-		self->cred_info[idx].scheme.ptr = PyString_AsString(obj->scheme);
-		self->cred_info[idx].scheme.slen = 
-			strlen(PyString_AsString(obj->scheme));
-		self->cred_info[idx].username.ptr = PyString_AsString(obj->username);
-		self->cred_info[idx].username.slen = 
-			strlen(PyString_AsString(obj->username));
-		self->cred_info[idx].data_type = obj->data_type;
-	} 
-	else
-	{
-		return NULL;
-	}
-	Py_INCREF(Py_None);
-	return Py_None;
-}
-
-static PyMethodDef acc_config_methods[] = {
-    {
-		"get_proxy", (PyCFunction)acc_config_get_proxy, METH_VARARGS,
-		"Return proxy at specified index"
-    },
-	{
-		"set_proxy", (PyCFunction)acc_config_set_proxy, METH_VARARGS,
-		"Set proxy at specified index"
-    },
-	{
-		"get_cred_info", (PyCFunction)acc_config_get_cred_info, METH_VARARGS,
-		"Return cred_info at specified index"
-    },
-	{
-		"set_cred_info", (PyCFunction)acc_config_set_cred_info, METH_VARARGS,
-		"Set cred_info at specified index"
-    },
-    {NULL}  /* Sentinel */
-};
-
 
 
